--[[
Author: Starinnia
Helper mod for the Thaddius encounter in Naxxramas
$Date: 2008-12-20 04:00:18 +0000 (Sat, 20 Dec 2008) $
$Revision: 2 $

Copyright (c) 2007-2008 Michael J. Murray aka Starinnia of Lothar

This software is provided 'as-is', without any express or implied
warranty. In no event will the authors be held liable for any damages
arising from the use of this software.

Permission is granted to anyone to use this software for any purpose,
including commercial applications, and to alter it and redistribute it
freely, subject to the following restrictions:

1. The origin of this software must not be misrepresented; you must not
claim that you wrote the original software. If you use this software
in a product, an acknowledgment in the product documentation would be
appreciated but is not required.

2. Altered source versions must be plainly marked as such, and must not be
misrepresented as being the original software.

3. This notice may not be removed or altered from any source
distribution.
]]

local ChargeMeter = LibStub("AceAddon-3.0"):NewAddon("ChargeMeter", "AceConsole-3.0", "AceEvent-3.0", "AceTimer-3.0")
local LSM = LibStub("LibSharedMedia-3.0")
local L = LibStub("AceLocale-3.0"):GetLocale("ChargeMeter")

local posTex = "Interface\\Icons\\Spell_ChargePositive"
local negTex = "Interface\\Icons\\Spell_ChargeNegative"
local newCharge
local currentCharge
local timer

local defaults = {
	profile = {
		
	},
}

local opts
local function getOpts()
	if not opts then
		opts = {
			type = 'group',
			args = {
				main = {
					type = 'group',
					name = L["Main"],
					args = {
					
					},
					profiles = LibStub("AceDBOptions-3.0"):GetOptionsTable(self.db)
				},
			},
		}
	end
	return opts
end

function ChargeMeter:OnInitialize()

end

function ChargeMeter:OnEnable()
	self:RegisterEvent("CHAT_MSG_MONSTER_YELL", "BossYell")
end

function ChargeMeter:BossYell(msg)
	if msg:find(L["Eat... your... bones..."]) or msg:find(L["Break... you!!"]) or msg:find(L["Kill..."]) then
		self:Print("Charge Meter activated.")
		--self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED", "CombatLogEvent")
		timer = self:ScheduleRepeatingTimer("ChargeCheck", 3)
		self:RegisterEvent("PLAYER_REGEN_ENABLED", "ResetMeter")
	end
end

function ChargeMeter:ResetMeter()
	self:UnregisterEvent("PLAYER_REGEN_ENABLED")
	self:UnregisterTimer(timer)
	timer = nil
	newCharge, currentCharge = nil, nil
end

--function ChargeMeter:CombatLogEvent(event, timestamp, subevent, sID, sName, sFlags, dID, dName, dFlags, spellID, spellName)
--	if spellID == 28089 then
--		if event == "SPELL_CAST_START" then
--			timer = self:ScheduleTimer("ChargeCheck", 4)
--		end
--	end
--end

function ChargeMeter:ChargeCheck()
	while UnitDebuff("player", i) do
		local _, _, icon, count = UnitDebuff("player", i)
		if icon == negTex then
			if count > 1 then return end
			newCharge = "negative"
		elseif icon == posTex then
			if count > 1 then return end
			newCharge = "positive"
		end
		i = i + 1
	end
	
	if newCharge then
		if currentCharge == newCharge then
			--no change
			self:Print("No charge change")
		else
			--move yer ass
			self:Print("New Charge, move it!")
		end
		currentCharge = newCharge
	end
	newCharge = nil
end
